@page "/shipmentfinder"

@using AntDesign
@using System.Text;
@using System.Net;
@using FIOWeb.Models
@using FIOWeb.JsonPayloads
@using Newtonsoft.Json
@using CurrieTechnologies.Razor.Clipboard

@inject ClipboardService Clipboard
@inject IMatToaster Toaster
@inject NavigationManager NavManager
@inject GlobalAppState GlobalAppState

@implements IDisposable

<h1>Shipment Finder</h1>
<MatThemeProvider Theme="@blackTheme">
<RadioGroup @bind-Value="SelectedSearchOption" ButtonStyle="solid">
    <Radio RadioButton Value="@("Origin")">Origin</Radio>
    <Radio RadioButton Value="@("Destination")">Destination</Radio>
    <Radio RadioButton Value="@("All")">All</Radio>
</RadioGroup>
<Popover Title="" Placement="@Placement.BottomLeft">
    <ContentTemplate>
        <p>
            <b>Origin</b> - Find shipments where pickup location is at planet specified<br/>
            <b>Destination</b> - Find shipments where dropoff location is at planet specified<br/>
            <b>All</b> - Show all contracts with planet specified used for jump distance calculations
        </p>
    </ContentTemplate>
    <ChildContent>
        <MatIcon style="transform:scale(0.75)" Icon="info"/>
    </ChildContent>
</Popover>
<MatAutocompleteList Style="margin-left: 20px" Items="@AllPlanetsAndCXs" OnTextChanged="OnPlanetSearchStringChanged" Label="Planet or Station" Required="true"/>

@if (SearchLoading)
{
    <Spin style="margin-left: 20px" size="large"/>
}
else
{
    <MatButton Disabled="@(String.IsNullOrWhiteSpace(PlanetSearchString))"  Style="margin-left: 20px; outline:0" Icon="search" OnClick="SearchClick">Search</MatButton>
}
</MatThemeProvider>

<MatTable AllowSelection="true" 
          Items="@ShipmentSearchModels"
          class="mat-elevation-z5" 
          ShowPaging="true" 
          @bind-PageSize="ShipmentSearchPageSize" 
          Striped="true" 
          UseSortHeaderRow="true" 
          Style="font-size:10px">
    <MatTableHeader>
        <MatSortHeaderRow SortChanged="@SortShipmentData">
            <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="Link"></MatSortHeader>
            <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="PlanetNaturalId">Contract Planet</MatSortHeader>
            <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="OriginPlanetNaturalId">Origin</MatSortHeader>
            <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="DestinationPlanetNaturalId">Destination</MatSortHeader>
            <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="JumpDistance">Jumps</MatSortHeader>
            <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="PayoutPrice">Payout</MatSortHeader>
            <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="PayoutPricePer500">Payout/500 Units</MatSortHeader>
            <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="Weight">Weight</MatSortHeader>
            <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="Volume">Volume</MatSortHeader>
            <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="DeliveryTime">Time</MatSortHeader>
            <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="RatingDisplay">Rating</MatSortHeader>
            <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="CreatorCompanyCode">Company Code</MatSortHeader>
        </MatSortHeaderRow>
    </MatTableHeader>
    <MatTableRow>
        <td style="width:75px">
            <MatThemeProvider Theme="@blackTheme">
                <MatButton Style="font-size:22; outline:0" Icon="link" OnClick="@(() => { _ = OnClickLink(context.PlanetNaturalId, context.ContractNaturalId);})"></MatButton>
            </MatThemeProvider>
        </td>
        <td style="width:125px">@context.PlanetDisplayName</td>
        <td style="width:125px">
            @context.OriginPlanetDisplayName 
            @if ( context.SourceIsGaseous )
            {
                <Popover Placement="@Placement.RightTop" Title="Planet Is Gaseous">
                    <ContentTemplate>
                        Gaseous planets require more fuel for take-off and landing.
                    </ContentTemplate>
                    <ChildContent>
                        <MatIcon Style="font-size:16px; color: orangered" Icon="warning"/>
                    </ChildContent>
                </Popover>
            }
        </td>
        <td style="width:125px">
            @context.DestinationPlanetDisplayName 
            @if( context.DestinationIsGaseous)
            {
                <Popover Placement="@Placement.RightTop" Title="Planet Is Gaseous">
                    <ContentTemplate>
                        Gaseous planets require more fuel for take-off and landing.
                    </ContentTemplate>
                    <ChildContent>
                        <MatIcon Style="font-size: 16px; color: orangered" Icon="warning"/>
                    </ChildContent>
                </Popover>
            }
        </td>
        <td style="width:50px">@context.JumpDistance</td>
        <td style="width:75px">@context.PayoutDisplay</td>
        <td style="width:75px">@((MarkupString)context.PayoutPricePer500UnitsDisplay)</td>
        <td style="width:75px">@context.CargoWeightDisplay</td>
        <td style="width:75px">@((MarkupString)context.CargoVolumeDisplay)</td>
        <td style="width:75px">@context.DeliveryTimeDisplay</td>
        <td style="width:75px">@context.RatingDisplay</td>
        <td style="width:75px">@context.CreatorCompanyCode</td>
        <td style="width:100%"></td>
    </MatTableRow>
</MatTable>